Index: objc-private/selector.h
===================================================================
--- objc-private/selector.h     (revision 168140)
+++ objc-private/selector.h     (working copy)
@@ -25,10 +25,6 @@
 #ifndef __objc_private_selector_INCLUDE_GNU
 #define __objc_private_selector_INCLUDE_GNU
 
-#ifdef __cplusplus
-extern "C" {
-#endif /* __cplusplus */
-
 /* Private runtime functions that may go away or be rewritten or
    replaced.  */
 
@@ -58,8 +54,4 @@
 SEL
 sel_get_any_uid (const char *name);
 
-#ifdef __cplusplus
-}
-#endif /* __cplusplus */
-
 #endif /* not __objc_private_selector_INCLUDE_GNU */
Index: objc-private/sarray.h
===================================================================
--- objc-private/sarray.h       (revision 168140)
+++ objc-private/sarray.h       (working copy)
@@ -39,10 +39,6 @@
 
 #include <stddef.h>
 
-#ifdef __cplusplus
-extern "C" {
-#endif /* __cplusplus */
-
 extern int nbuckets;           /* for stats */
 extern int nindices;
 extern int narrays;
@@ -232,8 +228,4 @@
     return (array->empty_bucket->elems[0]);
 }
 
-#ifdef __cplusplus
-}
-#endif /* __cplusplus */
-
 #endif /* __sarray_INCLUDE_GNU */
Index: objc-private/runtime.h
===================================================================
--- objc-private/runtime.h      (revision 168140)
+++ objc-private/runtime.h      (working copy)
@@ -48,10 +48,6 @@
 #include <stddef.h>            /* so noone else will get system versions */
 #include <assert.h>
 
-#ifdef __cplusplus
-extern "C" {
-#endif /* __cplusplus */
-
 extern BOOL __objc_add_class_to_hash (Class);   /* (objc-class.c) */
 extern void __objc_init_class_tables (void);    /* (objc-class.c) */
 extern void __objc_init_dispatch_tables (void); /* (objc-dispatch.c) */
@@ -65,8 +61,8 @@
 extern void class_add_method_list (Class, struct objc_method_list *);
 
 /* Registering instance methods as class methods for root classes */
-extern void __objc_register_instance_methods_to_class(Class);
-extern struct objc_method * search_for_method_in_list(struct objc_method_list * list, SEL op);
+extern void __objc_register_instance_methods_to_class (Class);
+extern struct objc_method * search_for_method_in_list (struct objc_method_list * list, SEL op);
 
 extern void
 __objc_update_classes_with_methods (struct objc_method *method_a, struct objc_method *method_b); /* class.c */
@@ -80,8 +76,4 @@
 BOOL __objc_responds_to (id object, SEL sel); /* for internal use only! */
 extern void __objc_generate_gc_type_description (Class);
 
-#ifdef __cplusplus
-}
-#endif /* __cplusplus */
-
 #endif /* not __objc_private_runtime_INCLUDE_GNU */
Index: objc-private/hash.h
===================================================================
--- objc-private/hash.h (revision 168140)
+++ objc-private/hash.h (working copy)
@@ -30,10 +30,6 @@
 #include <stddef.h>
 #include <string.h>
 
-#ifdef __cplusplus
-extern "C" {
-#endif /* __cplusplus */
-
 /*
  * This data structure is used to hold items
  *  stored in a hash table.  Each node holds 
@@ -202,10 +198,4 @@
     return ! strcmp ((const char *) k1, (const char *) k2);
 }
 
-
-#ifdef __cplusplus
-}
-#endif /* __cplusplus */
-
-
 #endif /* not __hash_INCLUDE_GNU */
Index: objc-private/protocols.h
===================================================================
--- objc-private/protocols.h    (revision 168140)
+++ objc-private/protocols.h    (working copy)
@@ -25,10 +25,6 @@
 #ifndef __objc_private_protocols_INCLUDE_GNU
 #define __objc_private_protocols_INCLUDE_GNU
 
-#ifdef __cplusplus
-extern "C" {
-#endif /* __cplusplus */
-
 /* This function needs to be called at startup by init.c.  */
 void
 __objc_protocols_init (void);
@@ -39,8 +35,4 @@
 void
 __objc_protocols_add_protocol (const char *name, Protocol *object);
 
-#ifdef __cplusplus
-}
-#endif /* __cplusplus */
-
 #endif /* not __objc_private_protocols_INCLUDE_GNU */
Index: objc-private/accessors.h
===================================================================
--- objc-private/accessors.h    (revision 168140)
+++ objc-private/accessors.h    (working copy)
@@ -25,16 +25,8 @@
 #ifndef __objc_private_accessors_INCLUDE_GNU
 #define __objc_private_accessors_INCLUDE_GNU
 
-#ifdef __cplusplus
-extern "C" {
-#endif /* __cplusplus */
-
 /* This function needs to be called at startup by init.c.  */
 void
 __objc_accessors_init (void);
 
-#ifdef __cplusplus
-}
-#endif /* __cplusplus */
-
 #endif /* not __objc_private_accessors_INCLUDE_GNU */
Index: objc-private/objc-list.h
===================================================================
--- objc-private/objc-list.h    (revision 168140)
+++ objc-private/objc-list.h    (working copy)
@@ -27,10 +27,6 @@
 #ifndef __GNU_OBJC_LIST_H
 #define __GNU_OBJC_LIST_H
 
-#ifdef __cplusplus
-extern "C" {
-#endif /* __cplusplus */
-
 struct objc_list {
   void *head;
   struct objc_list *tail;
@@ -92,8 +88,4 @@
     }
 }
 
-#ifdef __cplusplus
-}
-#endif /* __cplusplus */
-
 #endif /* not __GNU_OBJC_LIST_H */
Index: objc-private/objc-sync.h
===================================================================
--- objc-private/objc-sync.h    (revision 168140)
+++ objc-private/objc-sync.h    (working copy)
@@ -25,17 +25,9 @@
 #ifndef __objc_private_objc_sync_INCLUDE_GNU
 #define __objc_private_objc_sync_INCLUDE_GNU
 
-#ifdef __cplusplus
-extern "C" {
-#endif /* __cplusplus */
-
 /* This function needs to be called at startup before @synchronized()
    can be used.  */
 void
 __objc_sync_init (void);
 
-#ifdef __cplusplus
-}
-#endif /* __cplusplus */
-
 #endif /* not __objc_private_objc_sync_INCLUDE_GNU */
Index: ChangeLog
===================================================================
--- ChangeLog   (revision 168147)
+++ ChangeLog   (working copy)
@@ -1,3 +1,15 @@
+2010-12-22  Nicola Pero  <nicola.pero@meta-innovation.com>
+
+       * objc-private/accessors.h: Removed 'extern "C"' guards.  This
+       file is never compiled with C++.
+       * objc-private/hash.h: Same change.
+       * objc-private/objc-list.h: Same change.
+       * objc-private/objc-sync.h: Same change.
+       * objc-private/protocols.h: Same change.
+       * objc-private/runtime.h: Same change.
+       * objc-private/sarray.h: Same change.
+       * objc-private/selector.h: Same change.
+
 2010-12-21  Nicola Pero  <nicola.pero@meta-innovation.com>
 
        PR libobjc/18764